       ORG 0100H
;   
; MICROCHESS 1.0  DISASSEMBLED  
;   
CPM  EQU  0
CR   EQU  00DH  
;   
START:  LXI SP,STACK
   CALL LNFEED  
   LXI  H,MCHESS
   CALL CRTDIS  
   LXI  H,AUTHOR
   CALL CRTDIS  
   LXI  H,DASHES
   CALL CRTDIS  
BEGIN:  CALL LNFEED 
   CALL SUBR4   
   LXI  H,DATA2 
   SHLD PNTR2   
   LXI  H,DATA1 
   SHLD PNTR1   
   LXI  H,DATA3 
   SHLD PNTR3   
   LXI  H,MOPEN 
   SHLD MPNTR   
   XRA  A   
   STA  INCHEK  
   STA  MCASTL  
   STA  WSIDE   
   STA  MATFLG  
   STA  ADDRS1  
   STA  L0A76   
   MVI  A,010H  
   STA  L0A77   
   MVI  A,0EEH  
   STA  L0A4D   
   STA  MVALUE  
   LXI  H,COLOR 
   CALL PRINT   
   CALL INPUT   
   CALL OUTPUT  
   MOV  A,B 
   RRC  
   JNC  PBOARD  
   MVI  A,1 
   STA  WSIDE   
   CALL SUBR5   
PBOARD: CALL BOARD  
RESUME: CALL LNFEED 
RESU1:  LXI SP,STACK
   LXI  H,TTYO+1
   SHLD SPSAVE  
   LXI  H,02020H
   SHLD XMOVE   
   LXI  H,CLEAR 
   CALL PRINT   
   CALL SUBR2   
   CALL LNFEED  
   LXI  H,SRCMV 
   MOV  A,M 
   CPI  'G' 
   JZ   GOCMD   
   CPI  'D' 
   JZ   DISPLY  
   CPI  'E' 
   JZ   EXCHNG  
   CPI  'S' 
   JZ   SPEED   
   CPI  'O' 
   JZ   CASTLE  
   CPI  'R' 
   JZ   RESIGN  
   CPI  'A' 
   JZ   AUTO
   CPI  'N' 
   JZ   NODISP  
   CALL SUBR1   
   LDA  ENDMSG  
   CPI  'M' 
   JZ   MULTI   
   CPI  '=' 
   JZ   PROMOT  
   CPI  CR  
   JNZ  ERRMSG  
   CALL SUBR6   
AUTOD:  DB  0   
AUTO1:  DB  0   
   DB  0
GOCMD:  CALL FINDMV 
   LDA  MCASTL  
   ORA  A   
   JZ   MATCH   
   LXI  H,0204FH
   SHLD TMOVE   
   LXI  H,04F20H
   SHLD FMOVE   
   XRA  A   
   STA  MCASTL  
   JMP  SOURCE  
MATCH:  CALL L01AD  
   CALL SUBR3   
   LDA  MATED   
   CPI  0FFH
   JZ   CMATED  
SOURCE: LXI  H,MMOVE
   CALL PRINT   
   LDA  MATFLG  
   CPI  0FFH
   JZ   L0317   
   LDA  INCHEK  
   ORA  A   
   JZ   LINFED  
   LXI  H,CHECK 
   CALL PRINT   
LINFED: CALL LNFEED 
AUTOA:  DB  0   
AUTOB:  DB  0   
   DB  0
   JMP  RESU1   
MULTI:  CALL SUBR6  
   JMP  RESU1   
ERRMSG:  LXI  H,INPERR  
   CALL PRINT   
   CALL LNFEED  
   JMP  RESU1   
CMATED:  LXI  H,UMATE   
   CALL CRTDIS  
ENDGAM: CALL BOARD  
   CALL LNFEED  
   LXI  H,NEWGAM
   CALL PRINT   
   CALL INPUT   
   CALL OUTPUT  
   MOV  A,B 
   CPI  'Y' 
   JNZ  GAMEND  
   CALL LNFEED  
   JMP  BEGIN   
PRINT:  MOV  A,M
   CPI  CR  
   RZ   
   MOV  B,A 
   CALL OUTPUT  
   INX  H   
   JMP  PRINT   
SUBR1:  LHLD SRCMV  
   CALL ASCII   
   STA  SMOVE   
   LHLD DSTMV   
   CALL ASCII   
   STA  DMOVE   
   STA  MVALUE  
   LDA  SMOVE   
   LXI  H,CKPAWN
   MVI  C,01FH  
LOOP1:  CMP  M  
   JZ   NEXT1   
   DCX  H   
   DCR  C   
   JP   LOOP1   
   JMP  ERRMSG  
NEXT1:  MOV  A,C
   STA  L0A4D   
   STA  MATED   
   RET  
ASCII:  MOV  A,L
   ANI  00FH
   RAL  
   RAL  
   RAL  
   RAL  
   MOV  B,A 
   MOV  A,H 
   ANI  00FH
   ORA  B   
   MOV  B,A 
   ANI  088H
   JNZ  ERRMSG  
   MOV  A,B 
   RET  
L01AD:  LDA  SMOVE  
   MOV  B,A 
   CALL DECODE  
   LHLD TEMPMV  
   SHLD FMOVE   
   LDA  DMOVE   
   MOV  B,A 
   CALL DECODE  
   LHLD TEMPMV  
   SHLD TMOVE   
   RET  
GAMEND:  CALL LNFEED
   CALL LNFEED  
   LXI  H,THANK 
   CALL PRINT   
   CALL LNFEED  
   JMP  CPM  
CRTDIS: CALL PRINT  
   CALL LNFEED  
   RET  
SPEED:  CALL LNFEED 
   LXI  H,GSPEED
   CALL PRINT   
   CALL INPUT   
   CALL OUTPUT  
   MOV  A,B 
   CPI  'S' 
   JZ   SUPERB  
   CPI  'B' 
   JZ   BLITZ   
   CPI  'N' 
   JZ   NORMAL  
   JMP  ERRMSG  
SUPERB: MVI  B,0
   MVI  C,0FFH  
   JMP  SPDONE  
BLITZ:  MVI  B,0
   MVI  C,0FBH  
   JMP  SPDONE  
NORMAL: MVI  B,8
   MVI  C,0FBH  
SPDONE: MOV  A,B
   STA  TIMEA+1 
   MOV  A,C 
   STA  TIMEB+1 
   JMP  RESUME  
RESIGN: CALL LNFEED 
   LXI  H,QUITR 
   CALL PRINT   
   JMP  ENDGAM  
EXCHNG: CALL SUBR5  
   LDA  WSIDE   
   ORA  A   
   JZ   SWITCH  
   XRA  A   
   JMP  NOSWAP  
SWITCH: MVI  A,1
NOSWAP: STA  WSIDE  
   JMP  RESU1   
BOARD:  CALL LNFEED 
   CALL LNFEED  
   MVI  D,0 
   LXI  H,TLINE 
   CALL CRTDIS  
MIDLIN: MOV  A,D
   ORA  A   
   JZ   SIXTEE  
   LXI  H,BLANK 
   DB  0
   DB  0
   DB  0
SIXTEE: MVI  B,'!'  
   CALL OUTPUT  
   MVI  B,020H  
   CALL OUTPUT  
CMPARE: LXI  H,CKPAWN   
   MVI  C,01FH  
NEXCMP: MOV  A,M
   CMP  D   
   JZ   EXIDIS  
   DCX  H   
   DCR  C   
   JP   NEXCMP  
   MOV  A,D 
   ANI  00FH
   MOV  E,A 
   MOV  A,D 
   ANI  0F0H
   RRC  
   RRC  
   RRC  
   RRC  
   ADD  E   
   RAR  
   JC   COLOUT  
   MVI  B,' '   
   JMP  CUSTOM  
COLOUT: MVI  B,':'  
CUSTOM: CALL OUTPUT 
   CALL OUTPUT  
SPACE:  MVI  B,' '  
   CALL OUTPUT  
   INR  D   
   MOV  A,D 
   ANI  00FH
   CPI  8   
   JNZ  CMPARE  
   MVI  B,'!'   
   CALL OUTPUT  
   CALL LNFEED  
   MOV  A,D 
   ADI  8   
   MOV  D,A 
   JP   MIDLIN  
   LXI  H,BLINE 
   CALL CRTDIS  
   CALL LNFEED  
   RET  
EXIDIS:  MOV  A,C   
   CPI  010H
   JNC  LOOP2B  
   LDA  WSIDE   
   ORA  A   
   JNZ  LOOP2A  
LOOP2:  LDA  LPCNT2 
   MOV  B,A 
   JMP  NEXT2   
LOOP2A:  LDA  COUNT2
   MOV  B,A 
   JMP  NEXT2   
LOOP2B: LDA  WSIDE  
   ORA  A   
   JNZ  LOOP2   
   JMP  LOOP2A  
NEXT2:  CALL OUTPUT 
   MOV  A,C 
   ANI  00FH
   MOV  C,A 
   MVI  B,0 
   LXI  H,L0A85 
   DAD  B   
   MOV  B,M 
   CALL OUTPUT  
   JMP  SPACE   
AUTO:   MVI  A,0CDH 
   STA  AUTOD   
   STA  AUTOA   
   LXI  H,BOARD 
   SHLD AUTO1   
   SHLD AUTOB   
   JMP  RESUME  
NODISP: LXI  H,0
   SHLD AUTOD   
   SHLD AUTO1   
   SHLD AUTOA   
   SHLD AUTOB   
   JMP  RESUME  
L0317:  LXI  H,CMATE
   CALL PRINT   
   JMP  ENDGAM  
SUBR2:  LXI  H,SRCMV
   MVI  C,0 
LOOP3:  CALL INPUT  
   MOV  A,B 
   MOV  M,A 
   CPI  CR  
   JZ   NEXT3   
   CPI  018H
   JZ   RESUME  
   CALL OUTPUT  
   INX  H   
   INR  C   
   JMP  LOOP3   
NEXT3:  XRA  A  
   CMP  C   
   JZ   LOOP3   
   RET  
DISPLY:  CALL BOARD 
   JMP  RESU1   
PROMOT: CALL SUBR1  
   LXI  H,CKPAWN
   MVI  C,00FH  
   LDA  SMOVE   
LOOP4:  CMP  M  
   JZ   NEXT4   
   DCX  H   
   DCR  C   
   JP   LOOP4   
NEXT4:  MVI  M,0CCH 
   LXI  H,L0A8C 
   MVI  C,7 
   LDA  L0D10   
LOOP5:  CMP  M  
   JZ   NEXT5   
   DCX  H   
   DCR  C   
   JP   LOOP5   
   JMP  ERRMSG  
NEXT5:  LXI  H,CTABLE   
   MVI  B,0 
   DAD  B   
   MVI  A,0CCH  
   CMP  M   
   JZ   PROM1   
   DCX  H   
   CMP  M   
   JNZ  ERRMSG  
PROM1:  LDA  DMOVE  
   MOV  M,A 
   LDA  L0D11   
   CPI  'M' 
   JZ   RESUME  
   CPI  CR  
   JZ   AUTOD   
   JMP  ERRMSG  
SUBR3:  LDA  DMOVE  
   ANI  0F0H
   CPI  070H
   RNZ  
   LDA  MATED   
   MOV  C,A 
   ANI  8   
   RZ   
   LXI  H,MTABLE
   MVI  B,0 
   DAD  B   
   MVI  A,0CCH  
   MOV  M,A 
   LXI  H,MQUEEN
   MVI  E,0 
LOOP6:  CMP  M  
   JZ   NEXT6   
   INX  H   
   INR  E   
   JMP  LOOP6   
NEXT6:  LDA  DMOVE  
   MOV  M,A 
   MVI  A,03DH  
   STA  XMOVE   
   LXI  H,L0A86 
   MVI  D,0 
   DAD  D   
   MOV  A,M 
   STA  TMOVE+1 
   RET  
CASTLE: LDA  DASH   
   CPI  04FH
   JNZ  ERRMSG  
   LDA  DSTMV+1 
   CPI  04FH
   JNZ  REGMOV  
   LDA  WSIDE   
   ORA  A   
   JZ   CAST1   
   LDA  CTABLE  
   CPI  074H
   JNZ  ERRMSG  
   MVI  A,072H  
   STA  CTABLE  
   MVI  A,073H  
   STA  CQROOK  
   STA  MVALUE  
   MVI  A,013H  
   STA  L0A4D   
   JMP  CAST2   
CAST1:  LDA  CTABLE 
   CPI  073H
   JNZ  ERRMSG  
   MVI  A,075H  
   STA  CTABLE  
   MVI  A,074H  
   STA  CQROOK  
   STA  MVALUE  
   MVI  A,013H  
   STA  L0A4D   
CAST2:  LDA  ENDMSG 
   CPI  'M' 
   JZ   RESUME  
   CPI  CR  
   JZ   AUTOD   
   JMP  ERRMSG  
REGMOV:  LDA  WSIDE 
   ORA  A   
   JZ   REGMV   
   LDA  CTABLE  
   CPI  074H
   JNZ  ERRMSG  
   MVI  A,076H  
   STA  CTABLE  
   MVI  A,075H  
   STA  CKROOK  
   STA  MVALUE  
   MVI  A,012H  
   STA  L0A4D   
   JMP  MULTMV  
REGMV:  LDA  CTABLE 
   CPI  073H
   JNZ  ERRMSG  
   MVI  A,071H  
   STA  CTABLE  
   MVI  A,072H  
   STA  CKROOK  
   STA  MVALUE  
   MVI  A,012H  
   STA  L0A4D   
MULTMV: LDA  DSTMV  
   CPI  'M' 
   JZ   RESUME  
   CPI  CR  
   JZ   AUTOD   
   JMP  ERRMSG  
FINDMV: LHLD ADDRS1 
   MOV  A,L 
   CPI  036H
   JNC  L056B   
   CALL LOOP7   
   PUSH PSW 
   LHLD ADDRS1  
   INX  H   
   SHLD ADDRS1  
   POP  PSW 
   JNC  L056B   
   CALL L054F   
SBLOOP: CALL SUB7A  
   CALL SUBR6   
   LDA  L0A4D   
   CPI  0   
   RNZ  
   MVI  A,2 
   STA  L0A4D   
   LDA  MVALUE  
   XRI  3   
   STA  MVALUE  
   STA  MCASTL  
   JMP  SBLOOP  
SUB7A:  LXI  H,MTABLE   
   LDA  L0A4D   
   STA  MATED   
   MOV  C,A 
   MVI  B,0 
   DAD  B   
   MOV  A,M 
   STA  SMOVE   
   LDA  MVALUE  
   STA  DMOVE   
   RET  
LOOP7:  CALL L0504  
   JZ   NEXT7   
   CALL L051C   
   LXI  H,L0A77 
   DCR  M   
   JP   LOOP7A  
   XRA  A   
   MVI  H,0 
   MVI  L,0F0H  
   SHLD ADDRS1  
LOOP7A:  JC   LOOP7 
   RET  
NEXT7:  CALL L0529  
   LHLD ADDRS1  
   XCHG 
   LHLD PNTR3   
   DAD  D   
   MOV  A,M 
   STA  L0A4D   
   LHLD MPNTR   
   DAD  D   
   MOV  A,M 
   STA  MVALUE  
   STC  
   RET  
L0504:  LHLD ADDRS1 
   XCHG 
   LHLD PNTR2   
   DAD  D   
   LDA  L0A4D   
   CMP  M   
   JNZ  L051B   
   LHLD PNTR1   
   DAD  D   
   LDA  MVALUE  
   CMP  M   
L051B:  RET 
L051C:  LHLD ADDRS1 
   MOV  A,L 
   ADI  9   
   MOV  L,A 
   SHLD ADDRS1  
   CPI  036H
   RET  
L0529:  LHLD ADDRS1 
   PUSH H   
   LDA  L0A77   
   MOV  C,A 
   MVI  A,0FFH  
   STA  L0A77   
LOOP8:  CALL L051C  
   LXI  H,L0A77 
   INR  M   
   JNC  NEXT8   
   DCR  C   
   JM   NEXT8   
   CALL L0504   
   JZ   LOOP8   
NEXT8:  POP  H  
   SHLD ADDRS1  
   RET  
L054F:  LDA  TIMEA+1
   INR  A   
   MOV  D,A 
DELAY1:  MVI  B,5   
DELAY2:  MVI  C,0FFH
DELAY3:  MVI  A,0FFH
DELAY4:  DCR  A 
   JNZ  DELAY4  
   DCR  C   
   JNZ  DELAY3  
   DCR  B   
   JNZ  DELAY2  
   DCR  D   
   JNZ  DELAY1  
   RET  
L056B:  MVI  A,00CH 
   STA  L0A54   
   STA  SMOVE   
   MVI  C,014H  
   CALL L05DF   
   MVI  A,4 
   STA  L0A54   
   CALL L05DD   
   LDA  SMOVE   
   CPI  00FH
   JC   L05A3   
   LXI  H,MTABLE
   MVI  B,0 
   LDA  MATED   
   STA  L0A4D   
   MOV  C,A 
   DAD  B   
   MOV  A,M 
   STA  SMOVE   
   LDA  DMOVE   
   STA  MVALUE  
   CALL SUBR6   
   RET  
L05A3:  MVI  A,0FFH 
   STA  MATED   
   STA  SMOVE   
   STA  DMOVE   
   RET  
SUBR4:  LXI  H,BTABLE   
   LXI  D,MTABLE
   MVI  C,020H  
L05B7:  MOV  A,M
   STAX D   
   INX  H   
   INX  D   
   DCR  C   
   JNZ  L05B7   
   RET  
   CALL SUBR4   
SUBR5:  LXI  H,MTABLE   
   LXI  D,CTABLE
   MVI  C,010H  
L05CB:  MVI  A,077H 
   SUB  M   
   MOV  B,A 
   XCHG 
   MVI  A,077H  
   SUB  M   
   MOV  M,B 
   XCHG 
   MOV  M,A 
   INX  H   
   INX  D   
   DCR  C   
   JNZ  L05CB   
   RET  
L05DD:  MVI  C,010H 
L05DF:  LXI  H,L0A5D
   XRA  A   
MOVTWO:  MOV  M,A   
   INX  H   
   DCR  C   
   JP   MOVTWO  
L05E9:  MVI  A,010H 
   STA  L0A4D   
ELOOP:  LXI  H,L0A4D
   DCR  M   
   RM   
   CALL L0758   
   MVI  A,8 
   STA  L0A55   
   LDA  L0A4D   
   CPI  8   
   JP   EIGHT   
   CPI  6   
   JP   SIX 
   CPI  4   
   JP   FOUR
   CPI  1   
   JZ   BLOOP   
   JP   ONE 
ALOOP:  CALL L0698  
   JNZ  ALOOP   
   JMP  ELOOP   
BLOOP:  CALL L06A9  
   JNZ  BLOOP   
   JMP  ELOOP   
ONE:    MVI  A,4
   STA  L0A55   
CLOOP:  CALL L06A9  
   JNZ  CLOOP   
   JMP  ELOOP   
FOUR:   CALL L06A9  
   LDA  L0A55   
   CPI  4   
   JNZ  FOUR
   JMP  ELOOP   
SIX:    MVI  A,010H 
   STA  L0A55   
DLOOP:  CALL L0698  
   LDA  L0A55   
   CPI  8   
   JNZ  DLOOP   
   JMP  ELOOP   
EIGHT:  MVI  A,6
   STA  L0A55   
L065B:  CALL L06DA  
   JM   L066B   
   LDA  L0A52   
   ORA  A   
   JZ   L066B   
   CALL L0793   
L066B:  CALL L0758  
   LXI  H,L0A55 
   DCR  M   
   MOV  A,M 
   CPI  5   
   JZ   L065B   
L0678:  CALL L06DA  
   JC   L068B   
   JM   ELOOP   
   LDA  L0A52   
   ORA  A   
   JNZ  ELOOP   
   CALL L0793   
L068B:  LDA  MVALUE 
   ANI  0F0H
   CPI  020H
   JZ   L0678   
   JMP  ELOOP   
L0698:  CALL L06DA  
   JM   L06A1   
   CALL L0793   
L06A1:  CALL L0758  
   LXI  H,L0A55 
   DCR  M   
   RET  
L06A9:  CALL L06DA  
   JNC  L06C0   
   PUSH PSW 
   POP  H   
   SHLD L0A72   
   LDA  L0A52   
   ORA  A   
   JZ   L06A9   
   LHLD L0A72   
   PUSH H   
   POP  PSW 
L06C0:  JM   L06D2  
   LDA  L0A52   
   PUSH PSW 
   CALL L0793   
   POP  PSW 
   STA  L0A52   
   ORA  A   
   JZ   L06A9   
L06D2:  CALL L0758  
   LXI  H,L0A55 
   DCR  M   
   RET  
L06DA:  LDA  L0A55  
   MVI  B,0 
   LXI  H,CQPAWN
   MOV  C,A 
   DAD  B   
   LDA  MVALUE  
   ADD  M   
   STA  MVALUE  
   ANI  088H
   JNZ  L0751   
   LDA  MVALUE  
   MVI  C,01FH  
   LXI  H,CKPAWN
LUPE1:  CMP  M  
   JZ   NEXX1   
   DCX  H   
   DCR  C   
   JP   LUPE1   
   JMP  L0712   
NEXX1:  MOV  A,C
   CPI  010H
   JC   L0751   
   MVI  A,1 
   STA  L0A52   
   JMP  L0716   
L0712:  XRA  A  
   STA  L0A52   
L0716:  LDA  L0A54  
   ORA  A   
   JM   L074F   
TIMEA:  CPI  8  
   JP   L074F   
   PUSH PSW 
   LDA  L0A52   
   PUSH PSW 
   MVI  A,0F9H  
   STA  L0A54   
   STA  L0A53   
   CALL SUBR6   
   CALL SUBR5   
   CALL L05E9   
   CALL L0770   
   POP  PSW 
   STA  L0A52   
   POP  PSW 
   STA  L0A54   
   LDA  L0A53   
   ORA  A   
   JM   L074F   
   MVI  A,080H  
   ORA  A   
   STC  
   RET  
L074F:  XRA  A  
   RET  
L0751:  XRA  A  
   STA  L0A52   
   CMA  
   ORA  A   
   RET  
L0758:  LXI  H,MTABLE   
   MVI  B,0 
   LDA  L0A4D   
   MOV  C,A 
   DAD  B   
   MOV  A,M 
   STA  MVALUE  
   RET  
L0767:  CALL SUBR6  
   CALL SUBR5   
   CALL L05E9   
L0770:  CALL SUBR5  
L0773:  LXI  H,0
   DAD  SP  
   SHLD L0A57   
   LHLD SPSAVE  
   SPHL 
   POP  D   
   LXI  H,L0A55 
   MOV  M,D 
   LXI  H,L0A4D 
   MOV  M,E 
   POP  B   
   POP  H   
   MOV  M,C 
   POP  H   
   MOV  M,B 
   MOV  A,B 
   STA  MVALUE  
   JMP  L08A0   
L0793:  LDA  L0A54  
   ORA  A   
   MVI  D,0 
   MOV  E,A 
   JM   L0820   
   LDA  L0A4D   
   ORA  A   
   JZ   L07B2   
   MOV  B,A 
   MVI  A,8 
   CMP  E   
   JNZ  L07B2   
   LDA  L0A65   
   CMP  B   
   JZ   L07FB   
L07B2:  LXI  H,L0A62
   DAD  D   
   INR  M   
   MVI  A,1 
   CMP  B   
   JNZ  L07BE   
   INR  M   
L07BE:  LDA  L0A52  
   ORA  A   
   JZ   L07F2   
   MVI  C,00FH  
   LXI  H,CKPAWN
   LDA  MVALUE  
LUPE2:  CMP  M  
   JZ   NEXX2   
   DCX  H   
   DCR  C   
   JP   LUPE2   
   HLT  
NEXX2:  LXI  H,VALUES   
   MVI  B,0 
   DAD  B   
   MOV  A,M 
   LXI  H,L0A63 
   DAD  D   
   CMP  M   
   JC   L07EC   
   MOV  M,A 
   LXI  H,L0A65 
   DAD  D   
   MOV  M,C 
L07EC:  LXI  H,L0A64
   DAD  D   
   ADD  M   
   MOV  M,A 
L07F2:  MOV  A,E
   CPI  4   
   JZ   L07FC   
   JM   L0834   
L07FB:  RET 
L07FC:  LDA  L0A67  
   STA  L0A5C   
   XRA  A   
   STA  L0A54   
   CALL SUBR6   
   CALL SUBR5   
   CALL L05DD   
   CALL SUBR5   
   MVI  A,8 
   STA  L0A54   
   CALL L05E9   
   CALL L0773   
   JMP  L08AC   
L0820:  MVI  D,0FFH 
   CPI  0F9H
   JNZ  L0834   
   LDA  CTABLE  
   LXI  H,MVALUE
   CMP  M   
   RNZ  
   XRA  A   
   STA  L0A53   
   RET  
L0834:  LDA  L0A52  
   ORA  A   
   RZ   
   LDA  MVALUE  
   MVI  C,7 
   LXI  H,CQKNIG
LUPE3:  CMP  M  
   JZ   NEXX3   
   DCX  H   
   DCR  C   
   JNZ  LUPE3   
   RET  
NEXX3:  LXI  H,VALUES   
   MVI  B,0 
   DAD  B   
   MOV  A,M 
   LXI  H,L0A61 
   DAD  D   
   CMP  M   
   JC   L085B   
   MOV  M,A 
L085B:  DCX  D  
   MOV  A,E 
   STA  L0A54   
TIMEB:  CPI  0FBH   
   JZ   L0868   
   CALL L0767   
L0868:  LXI  H,L0A54
   INR  M   
   RET  
SUBR6:  LXI  H,0
   DAD  SP  
   SHLD L0A57   
   LHLD SPSAVE  
   SPHL 
   LDA  MVALUE  
   MOV  B,A 
   MVI  C,01FH  
   LXI  H,CKPAWN
LUPE4:  CMP  M  
   JZ   NEXX4   
   DCX  H   
   DCR  C   
   JP   LUPE4   
NEXX4:  MVI  M,0CCH 
   PUSH H   
   LXI  H,MTABLE
   MVI  D,0 
   LDA  L0A4D   
   MOV  E,A 
   DAD  D   
   PUSH H   
   MOV  C,M 
   MOV  M,B 
   PUSH B   
   LXI  H,L0A55 
   MOV  D,M 
   PUSH D   
L08A0:  LXI  H,0
   DAD  SP  
   SHLD SPSAVE  
   LHLD L0A57   
   SPHL 
   RET  
L08AC:  SUB  A  
   MVI  A,080H  
   LXI  H,L0A6A 
   ADD  M   
   INX  H   
   ADD  M   
   INX  H   
   ADD  M   
   LXI  H,L0A60 
   ADD  M   
   LXI  H,L0A5E 
   ADD  M   
   LXI  H,L0A6F 
   SUB  M   
   INX  H   
   SUB  M   
   LXI  H,L0A61 
   SUB  M   
   LXI  H,L0A5F 
   SUB  M   
   LXI  H,L0A5D 
   SUB  M   
   LXI  H,L0A6E 
   SUB  M   
   LXI  H,L0A62 
   SUB  M   
   JNC  L08DD   
   SUB  A   
L08DD:  RAR 
   ADI  040H
   LXI  H,L0A6B 
   ADD  M   
   INX  H   
   ADD  M   
   LXI  H,L0A63 
   SUB  M   
   RAR  
   ADI  090H
   LXI  H,L0A5C 
   ADD  M   
   ADD  M   
   ADD  M   
   ADD  M   
   LXI  H,L0A60 
   ADD  M   
   LXI  H,L0A63 
   SUB  M   
   SUB  M   
   INX  H   
   SUB  M   
   SUB  M   
   LXI  H,L0A5F 
   SUB  M   
   PUSH PSW 
   LDA  MVALUE  
   CPI  033H
   JZ   CENTER  
   CPI  034H
   JZ   CENTER  
   CPI  022H
   JZ   CENTER  
   CPI  025H
   JZ   CENTER  
   LDA  L0A4D   
   ORA  A   
   JZ   L0934   
   LXI  H,MTABLE
   MVI  B,0 
   MOV  C,A 
   DAD  B   
   MOV  A,M 
   CPI  010H
   JP   L0934   
CENTER: POP  PSW
   ADI  2   
   PUSH PSW 
L0934:  LDA  L0A63  
   LXI  H,VALUES
   CMP  M   
   JNZ  L0943   
   POP  PSW 
   SUB  A   
   JMP  L095B   
L0943:  LDA  L0A62  
   ORA  A   
   JNZ  L095A   
   LDA  L0A6D   
   ORA  A   
   JNZ  L095A   
   POP  PSW 
   MVI  A,0FFH  
   STA  MATFLG  
   JMP  L095B   
L095A:  POP  PSW
L095B:  MVI  C,4
   LXI  H,L0A54 
   MOV  M,C 
   LXI  H,SMOVE 
   STA  TSMOV   
   CMP  M   
   JC   L098E   
   JZ   L098E   
   STA  SMOVE   
   LDA  L0A4D   
   STA  MATED   
   LDA  MVALUE  
   STA  DMOVE   
   XRA  A   
   STA  INCHEK  
   LDA  L0A6B   
   LXI  H,VALUES
   CMP  M   
   JNZ  L098E   
   STA  INCHEK  
L098E:  RET 
DECODE: LXI  H,TEMPMV   
   MOV  B,A 
   RAR  
   RAR  
   RAR  
   RAR  
   CALL COLON   
   MOV  M,A 
   INX  H   
   MOV  A,B 
   CALL COLON   
   MOV  M,A 
   RET  
COLON:  ANI  00FH   
   ADI  030H
   CPI  ':' 
   RC   
   ADI  7   
   RET  
LNFEED: MVI  B,CR   
   CALL OUTPUT  
   MVI  B,00AH  
   CALL OUTPUT  
   MVI  B,07FH  
   CALL OUTPUT  
   CALL OUTPUT  
   RET  
OUTPUT: PUSH H  
   PUSH B   
   PUSH D   
   CALL JUOUT   
   POP  D   
   POP  B   
   POP  H   
   RET  
INPUT:  PUSH H  
   PUSH D   
   PUSH B   
   CALL JUINP   
   MOV  A,B 
   POP  B   
   POP  D   
   POP  H   
   ANI  07FH
   MOV  B,A 
   RET  
JUOUT:  JMP  0C019H 
JUINP:  JMP  UINPUT 
TEMPMV:  DW  04646H 
   DS  13   
   DB  4

MTABLE:  DB  3  
MQUEEN:  DW  0CCCCH 
   DW  01211H   
   DW  04602H   
   DW  0CCCCH   
   DW  010CCH   
   DW  0CC40H   
   DW  02234H   
   DB  034H 

CTABLE:  DB  076H   
    DB  5   
CKROOK:  DB  075H   
CQROOK:  DB  073H   
    DB  0CCH
    DB  0CCH
    DB  036H
CQKNIG:  DB  067H   
    DB  050H
    DB  066H
    DB  041H
    DB  065H
    DB  032H
    DB  053H
    DB  044H
CKPAWN:  DB  053H   
BTABLE:  DB  3  
    DB  4   
    DB  0   
    DB  7   
    DB  2   
    DB  5   
   DW  00601H   
   DW  01710H   
   DW  01611H   
   DW  01512H   
    DB  014H
    DB  013H
    DB  073H
    DB  074H
    DB  070H
    DB  077H
    DB  072H
    DB  075H
    DB  071H
    DB  076H
    DB  060H
    DB  067H
    DB  061H
    DB  066H
    DB  062H
    DB  065H
    DB  064H
CQPAWN:  DB  063H   
   DB  0F0H 
    DB  0FFH
   DW  01001H   
   DW  00F11H   
   DB  0EFH 
   DB  0F1H 
   DB  0DFH 
   DB  0E1H 
   DW  0F2EEH   
   DW  00E12H   
   DW  0211FH   
VALUES:  DB  010H   
    DB  00AH
   DW  00606H   
    DW  00404H  
    DW  00404H  
    DB  2   
    DB  2   
    DB  2   
    DB  2   
    DB  2   
    DB  2   
    DB  2   
    DB  2   
L0A4D:  DB  0FFH
MVALUE: DB  3   
MATED:  DB  0FFH
SMOVE:  DB  0FFH
DMOVE:  DB  0FFH
L0A52:  DB  0   
L0A53:  DB  0   
L0A54:  DB  4   
L0A55:  DW  0   
L0A57:  DB  074H
   DB  CR   
SPSAVE:  DW  00DDEH 
TSMOV:  DB  0B7H
L0A5C:  DB  0   
L0A5D:  DB  0   
L0A5E:  DB  0   
L0A5F:  DB  0   
L0A60:  DB  0   
L0A61:  DB  0   
L0A62:  DB  0   
L0A63:  DB  0   
L0A64:  DB  0   
L0A65:  DW  0   
L0A67:  DB  0   
   DW  0
L0A6A:  DB  0   
L0A6B:  DW  0   
L0A6D:  DB  0   
L0A6E:  DB  013H
L0A6F:  DB  2   
   DW  00B06H   
L0A72:  DW  08083H  
INCHEK:  DB  0  
ADDRS1: DB  0F1H
L0A76:  DB  0   
L0A77:  DB  0FFH
MCASTL:  DB  0  
PNTR3:  DW  00B01H  
MPNTR:  DW  00B37H  
PNTR2:  DW  00A95H  
PNTR1:  DW  00ACBH  
MATFLG: DB  0   
WSIDE:  DB  1   
LPCNT2: DB  057H
COUNT2: DB  042H
L0A85:  DB  04BH
L0A86:  DB  051H
   DB  052H 
   DB  052H 
   DB  042H 
   DB  042H 
   DB  04EH 
L0A8C:  DB  04EH
   DB  050H 
   DB  050H 
   DB  050H 
   DB  050H 
   DB  050H 
   DB  050H 
   DB  050H 
   DB  050H 
DATA2:  DW  01FEEH  
   DB  017H 
   DW  01616H   
   DB  014H 
   DW  01B16H   
   DW  0EE16H   
   DB  01FH 
   DW  0161EH   
   DB  014H 
   DW  01116H   
   DB  010H 
   DB  01DH 
   DW  01D1EH   
   DW  01A16H   
   DB  014H 
   DB  012H 
   DW  01117H   
   DW  01F11H   
   DW  01716H   
   DB  014H 
   DB  012H 
   DW  0151EH   
   DB  01BH 
   DB  012H 
   DB  01FH 
   DW  01416H   
   DB  012H 
   DW  0111EH   
   DB  014H 
   DW  0171EH   
   DB  01FH 
   DW  01416H   
   DB  01DH 
   DW  01D1EH   
   DB  017H 
   DB  012H 
   DB  01BH 
DATA1:  DW  043EEH  
   DB  055H 
   DB  052H 
   DB  033H 
   DB  063H 
   DB  054H 
   DB  055H 
   DB  066H 
   DW  053EEH   
   DB  044H 
   DB  052H 
   DB  063H 
   DB  064H 
   DB  063H 
   DB  072H 
   DB  045H 
   DB  043H 
   DB  042H 
   DB  055H 
   DB  056H 
   DB  066H 
   DB  075H 
   DB  052H 
   DB  062H 
   DB  052H 
   DB  044H 
   DB  055H 
   DW  03152H   
   DW  05375H   
   DW  05236H   
   DB  074H 
   DB  044H 
   DW  03155H   
   DW  04375H   
   DW  02264H   
   DW  05234H   
   DB  044H 
   DB  055H 
   DB  042H 
   DB  052H 
   DB  043H 
   DB  043H 
   DB  052H 
   DB  075H 
   DB  052H 
DATA3:  DB  00FH
   DW  00406H   
   DB  0
   DW  0010EH   
   DB  4
   DW  0070EH   
   DB  00FH 
   DW  0070EH   
   DB  5
   DB  00FH 
   DW  00105H   
   DW  0060CH   
   DW  00F06H   
   DB  00BH 
   DB  5
   DB  4
   DB  0
   DW  00606H   
   DB  00CH 
   DB  00FH 
   DB  7
   DW  00406H   
   DB  0
   DW  0040EH   
   DW  00107H   
   DW  00F07H   
   DW  00606H   
   DB  4
   DW  00B06H   
   DW  00006H   
   DB  00FH 
   DB  7
   DB  4
   DW  00F06H   
   DB  4
   DW  00606H   
   DB  4

MOPEN:  DB  033H
   DB  022H 
   DB  046H 
   DB  1
   DB  034H 
   DB  013H 
   DB  055H 
   DB  043H 
   DB  025H 
   DB  033H 
   DB  034H 
   DB  025H 
   DB  041H 
   DB  043H 
   DB  063H 
   DW  03214H   
   DW  02522H   
   DW  02124H   
   DW  01411H   
   DW  04406H   
   DB  052H 
   DB  035H 
   DW  02234H   
   DW  04125H   
   DW  02306H   
   DB  052H 
   DB  014H 
   DB  3
   DW  02234H   
   DW  04425H   
   DB  014H 
   DW  02223H   
   DW  00611H   
   DW  02234H   
   DW  02532H   
   DB  043H 
   DB  041H 
   DB  044H 
   DB  052H 
   DB  052H 
MCHESS: DB  'MICROCHESS             (C)'
   DB  ' 1977. '
   DB  CR   
AUTHOR: DB  'WRITTEN BY: P.JENNINGS & T. O"BRIEN.'  
   DB  CR   
DASHES: DB  '-------------------------------------' 
   DB  CR   
GSPEED: DB  'WHICH MODE ? (S,B,N) ' 
   DB  CR   
COLOR:  DB  'DO YOU WANT WHITE ? (Y,N) '
   DW  03A0DH   
CLEAR:  DB  '--=>'  
   DB  CR   
MMOVE:  DB  'MC : ' 
FMOVE:  DB  'FF-'   
TMOVE:  DB  'FF'
XMOVE:  DB  '  '
   DB  CR   
INPERR: DB  'INPUT ERROR-'  
   DB  CR   
UMATE:  DB  'CHECKMATE - YOU WIN!!!'
   DB  CR   
NEWGAM:  DB  'PLAY AGAIN ? (Y,N) '  
   DB  CR   
THANK:  DB  'THANKS FOR THE GAME...MICROCHESS. '
   DB  CR   
QUITR:  DB  'YOU RESIGNED - I WIN!!!'   
   DB  CR   
CMATE:  DB  '  CHECKMATE - I WIN!!!!'   
   DB  CR   
CHECK:  DB  ' CHECK!'   
   DB  CR   
TLINE:  DB  '+------ MICROCHESS -------+'   
   DB  CR   
BLANK:  DB  '!                    !'
   DB  CR   
BLINE:  DB  '+------ CHALLENGER -------+'   
   DB  CR   
SRCMV:  DB  '15'
DASH:   DB  '-' 
DSTMV:  DB  '05'
ENDMSG: DB  CR  
L0D10:  DB  018H
L0D11:  DW  07F7FH  
   DB  04DH 
   DB  CR   
   DS  51   
   DB  0CAH,6,0A4H,6
   DB  0CAH,6,0CAH,6
   DB  0CAH,6,0A4H,6
   DB  018H,6,0CAH,6
   DB  0A4H,6,018H,6
   DB  073H,7,068H,8
   DB  0CAH,6,0A4H,6
   DB  039H,0C1H,039H,0C1H  
   DB  039H,0C1H,090H,0C0H  
   DB  0B8H,0C0H,06EH,0C0H  
   DB  0FFH,07FH,7,080H 
   DB  07DH,00CH,0C5H,9 
   DB  7,080H,0FFH,07FH 
   DB  07DH,00CH,0BEH,9 
   DB  0D7H,1   
STACK:  DS  52  
   DW  0060AH   
   DB  027H,036H,0F7H,9 
   DB  3,00AH,1,3   
   DB  072H,075H,0EEH,9 
   DB  2,00AH,0,3   
   DB  014H,015H,0EDH,9 
   DB  1,00AH,0,2   
   DB  1,0,0EDH,9   
   DB  0ECH,9,0,3   
   DB  3,4,0EDH,9   
   DB  0ECH,9,011H,0
   DB  015H,5,0FEH,9
   DB  0ECH,9   
TTYO:   IN  0   
   ANI  080H
   JZ   TTYO
   MOV  A,B 
   OUT 1
   RET  
UINPUT: IN   0FAH   
   ANI  1   
   JNZ  UINPUT  
   IN   0FCH
   ANI  07FH
   MOV  B,A 
   RET  
L0F07:  DW  0   
   END  
